
#include <allegro5/allegro.h>

#include <stdio.h>

#include "m_config.h"
#include "m_globvars.h"

#include "g_misc.h"
#include "g_header.h"

#include "g_group.h"
#include "g_motion.h"
#include "g_method.h"
#include "g_proc.h"

#include "g_method_pr.h"
#include "g_method_std.h"

#include "v_interp.h"

extern struct template_struct templ [PLAYERS] [TEMPLATES_PER_PLAYER];

void run_cores_and_procs(void)
{

// fpr("\ncore 0 memory %i,%i,%i,%i,%i", w.core[0].memory[0], w.core[0].memory[1], w.core[0].memory[2], w.core[0].memory[3], w.core[0].memory[4]);

 run_motion();

 int c;
 struct core_struct* core;
// struct proc_struct* proc;
// int instructions;

 for (c = 0; c < w.max_cores; c ++)
	{

  if (w.core[c].exists == 0)
   continue;

  core = &w.core[c];

// run code:

//  core->execution_count --;

  w.debug_mode = w.debug_mode_general; // 0 or 1

  if (core->next_execution_timestamp == w.world_time)
  {
//   w.current_output_console = w.player[pr->player_index].output_console;
//   w.current_error_console = w.player[pr->player_index].error_console;
//   w.print_colour = PRINT_COL_LGREY; //w.player[pr->player_index].default_print_colour;
//   w.print_proc_action_value3 = 0; // can be set by the MTYPE_PR_STD method

/*
   if (core->power_used < core->power_capacity)
			{
				core->stress -= (core->power_capacity - core->power_used) / STRESS_REDUCTION_FACTOR;
				if (core->stress < 0)
					core->stress = 0;
			}
			 else
				{
     if (core->power_used > core->power_capacity)
			  {
				  core->stress += core->power_used - core->power_capacity;
			  }
				}

   core->stress_level = core->stress / core->power_capacity;

   if (core->stress_level >= STRESS_EXTREME)
			{
				hurt_proc(core->process_index, 5000, core->player_index);
				continue;
			}

			if (core->stress_level == STRESS_HIGH)
			{
				if (core->interface_active)
					lower_general_interface(core);
			}
*/

//			core->power_used_old = core->power_used;
			core->power_left = core->power_capacity;
			core->power_use_excess = 0;
//			core->interface_charged_this_cycle = 0;

   run_objects_before_execution(core);

   core->last_execution_timestamp = w.world_time;
   core->next_execution_timestamp = w.world_time + EXECUTION_COUNT;
   core->cycles_executed ++;

   execute_bcode(core, &templ[core->player_index][core->template_index].bcode, core->memory);

   core->messages_received = 0;
   core->message_reading = 0; // if this is >= core->messages_received, core has finished reading messages
   core->message_position = 0;

   core->contact_core_index = -1;
   core->damage_this_cycle = 0;
   core->damage_source_core_index = -1;

   run_objects_after_execution(core);
  }

  run_objects_each_tick(core);

	} // end of for c loop

/*
 for (p = 0; p < w.max_procs; p ++)
 {

  if (w.proc[p].exists == 0)
   continue;

  proc = &w.proc[p];
*/
/*
// if the proc has just been destroyed, it may still be deallocating (if so exists will be -1). A deallocating proc doesn't do anything:
  if (proc->exists == -1)
  {
   if (proc->destroyed_timestamp + DEALLOCATE_COUNTER < w.world_time)
   {
    proc->exists = 0;
    w.player[proc->player_index].processes --;
   }
   continue;
  }*/

// active object code here!
//   active_method_pass_after_execution(pr); // currently this is called immediately after each execution. If this is ever changed so that it runs after all procs have executed, may need to change the way some things work (like LISTEN)


// } // end of for p loop



// active_method_pass_each_tick(); // deals with methods that do stuff even when the proc isn't executing (e.g. acceleration, which accelerates for a certain duration)


}


